<template>
  <div class="sf-accordion-item" :class="{ disabled }">
    <!-- @slot -->
    <slot
      name="header"
      v-bind="{
        header,
        likes,
        dislikes,
        textRight,
        badge,
        isOpen,
        accordionClick,
        showChevron: $parent.showChevron,
      }"
    >
      <SfButton
        :aria-pressed="isOpen.toString()"
        :aria-expanded="isOpen.toString()"
        :class="{ 'sf-accordion-item__header--open': isOpen }"
        :title="header"
        :disabled="disabled"
        class="sf-button--pure sf-accordion-item__header"
        @click="accordionClick()"
      >
        <div class="sf-accordion-item__icon-text-wrapper">
          <slot name="icon"></slot>
          <span class="sf-accordion-item__text">
            {{ header }}
          </span>
        </div>

        <div class="sf-accordion-item__info-wrapper">
          <div v-if="likes" class="sf-accordion-item__likes">
            <SwGsIconThumbsUpSmall class="color-dark-secondary size-sm" />
            <span class="text-success">{{ likes }}</span>
          </div>

          <div v-if="dislikes" class="sf-accordion-item__dislikes">
            <SwGsIconThumbsDownSmall class="color-dark-secondary size-sm" />
            <span class="text-danger">{{ dislikes }}</span>
          </div>

          <div v-if="textRight" class="sf-accordion-item__text-right">
            {{ textRight }}
          </div>

          <slot name="badge">
            <div
              v-if="badge && !hideEmptyBadge"
              class="sf-accordion-item__badge sf-badge--number sf-badge"
              :class="badgeVariantClass"
            >
              <span>
                {{ badge }}
              </span>
            </div>
          </slot>

          <SwGsIconChevronRight
            class="sf-accordion-item__chevron dark-secondary size-sm"
            :class="{ 'is-open': isOpen }"
          />
        </div>
      </SfButton>
    </slot>
    <SfTransition transition="sf-expand">
      <div v-if="isOpen">
        <div class="sf-accordion-item__content">
          <!-- @slot -->
          <slot />
        </div>
      </div>
    </SfTransition>
  </div>
</template>

<script>
import { SfButton, SfChevron } from "@storefront-ui/vue";
import { focus } from "@storefront-ui/vue/src/utilities/directives";
import SfTransition from "@storefront-ui/vue/src/utilities/transitions/component/SfTransition";
import {
  SwGsIconChevronRight,
  SwGsIconThumbsDownSmall,
  SwGsIconThumbsUpSmall,
} from "../icons";

export default {
  name: "SwGsAccordionItem",
  directives: { focus },
  components: {
    SfChevron,
    SfButton,
    SfTransition,
    SwGsIconThumbsUpSmall,
    SwGsIconThumbsDownSmall,
    SwGsIconChevronRight,
  },
  props: {
    header: {
      type: String,
      default: "",
    },
    likes: {
      type: String,
      default: "",
    },
    dislikes: {
      type: String,
      default: "",
    },
    textRight: {
      type: String,
      default: "",
    },
    badge: {
      type: String | Number,
      default: "",
    },
    badgeVariant: {
      type: String,
      default: "primary",
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    hideEmptyBadge: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      isOpen: false,
    };
  },

  computed: {
    badgeVariantClass() {
      return "color-" + this.badgeVariant;
    },
  },
  methods: {
    /**
     * Fix to prevent the accordion items to stay open after page switch.
     * This forces the SFAccordion to use an empty header as the open element if all elements are closed.
     */
    toggleAccordionItem() {
      if (this.$parent.openHeader !== this.header) {
        this.$parent.openHeader = this.header;
      } else {
        this.$parent.openHeader = "";
      }

      this.$parent.setAsOpen();
    },

    close(options = null) {
      this.$parent.openHeader = "";
      this.$parent.setAsOpen();
      this.$emit("toggleItem", this.isOpen, options);
    },

    open(options = null) {
      this.$parent.openHeader = this.header;
      this.$parent.setAsOpen();
      this.$emit("toggleItem", this.isOpen, options);
    },

    accordionClick(options = null) {
      this.toggleAccordionItem();
      this.$emit("toggleItem", this.isOpen, options);
    },
  },
};
</script>
<style lang="scss">
@import "~@storefront-ui/shared/styles/components/organisms/SfAccordion.scss";

.sf-accordion-item__icon-text-wrapper,
.sf-accordion-item__info-wrapper,
.sf-accordion-item__likes,
.sf-accordion-item__dislikes {
  display: flex;
  align-items: center;
}

.sf-accordion-item__icon {
  margin-right: var(--spacer-xs);
}

.sf-accordion-item__text {
  font-size: var(--font-size--base);
}

.sf-accordion-item__badge {
  &.color-light {
    color: var(--c-text);
  }
}

.disabled {
  color: var(--c-text-muted);
}

.sf-accordion-item__likes,
.sf-accordion-item__dislikes,
.sf-accordion-item__text-right,
.sf-accordion-item__badge,
.sf-accordion-item__chevron {
  font-size: var(--font-size--sm);
  margin-left: var(--spacer-xs);
}

.sf-accordion-item__header {
  padding: 12px 0;
}

.sf-accordion-item__chevron {
  transition: all 0.3s ease;

  &.is-open {
    transform: rotate(90deg);
  }
}
</style>
